//***********************************************************
//*
//* File:           Configuration.java
//* Author:         Abhinav Kamra
//* Contact:        kamra@cs.columbia.edu
//* Update:         9.5.2003
//*
//* Description:    Configuration object for Project 1, CS4444
//*                 Fall 2003
//*
//*
//***********************************************************

package ui;
import java.util.*;

public final class Configuration implements IFCConfiguration {

    int[] _maxroundsbounds;
    int[] _numplayersbounds;
    int[] _numLbounds;
    int[] _numWbounds;

    
    int _maxrounds;
    int L, W;
    Class[] _classlist;
    Class[] _playerlist;
    String _logfile;
    int[] _playercopies;
    
    
    public void setMaxRounds(int __maxrounds) throws Exception {
        _maxrounds = __maxrounds;
    }

    public int maxRounds() throws Exception {
        return _maxrounds;
    }
    
    public int getPlayerCopies(int i) throws Exception {
	    return _playercopies[i];
    }

    public void setPlayerCopies(int[] copies) throws Exception {
	    _playercopies = new int[copies.length];
	    for(int i=0;i < copies.length;i++)
	    {
		    _playercopies[i] = copies[i];
	    }
    }

    public void setPlayerCopies(int i, int val) throws Exception {
	    _playercopies[i] = val;
    }

    public void setMaxRoundsBounds(int __min, int __max) throws Exception {
        _maxroundsbounds = new int[2];
        _maxroundsbounds[0] = __min;
        _maxroundsbounds[1] = __max;
    }
    
    public int maxRoundsMin() throws Exception {
        return _maxroundsbounds[0];
    }

    public int maxRoundsMax() throws Exception {
        return _maxroundsbounds[1];
    }

    public int numPlayers() throws Exception {
        return _playerlist.length;
    }
    
    public int minPlayers() throws Exception {
        return _numplayersbounds[0];
    }

    public int maxPlayers() throws Exception {
        return _numplayersbounds[1];
    }

    public void setNumPlayersBounds(int __min, int __max) throws Exception {
        _numplayersbounds = new int[2];
        _numplayersbounds[0] = __min;
        _numplayersbounds[1] = __max;
    }
    
    public int numPlayersMin() throws Exception {
        return _numplayersbounds[0];
    }

    public int numPlayersMax() throws Exception {
        return _numplayersbounds[1];
    }
    
    public void setGridL(int _x) throws Exception {
        L = _x;
    }
    
    public int GridL() throws Exception {
        return L;
    }

    public void setLBounds(int __min, int __max) throws Exception {
        _numLbounds = new int[2];
        _numLbounds[0] = __min;
        _numLbounds[1] = __max;
    }
    
    public void setGridW(int _y) throws Exception {
        W = _y;
    }
    
    public int GridW() throws Exception {
        return W;
    }

    public void setWBounds(int __min, int __max) throws Exception {
        _numWbounds = new int[2];
        _numWbounds[0] = __min;
        _numWbounds[1] = __max;
    }
    
    
    public void setClassList(Class[] __list) throws Exception {
        int _MAX = __list.length;
        
        _classlist = new Class[_MAX];
        System.arraycopy(__list, 0, _classlist, 0, _MAX);    
    }    
    
    public Class[] classList() throws Exception {
        int _MAX = _classlist.length;
        Class[] RET = new Class[_MAX];
        
        System.arraycopy(_classlist, 0, RET, 0, _MAX);
        return RET;    
    }
    
    public Class getClass(int __pos) throws Exception {
        return _classlist[__pos];
    }
    
    public void setClass(int __pos, Class __class) throws Exception {
        _classlist[__pos] = __class;
    }
    
    public void setPlayerList(Class[] __list) throws Exception {
        int _MAX = __list.length;
        
        if (_MAX < _numplayersbounds[0] || _MAX > _numplayersbounds[1]) {
            throw new Exception("Error:  Number of Players Out of Range: "+_MAX);
        }
        _playerlist = new Class[_MAX];
        System.arraycopy(__list, 0, _playerlist, 0, _MAX);
    } 
    
    public Class[] playerList() throws Exception {
	    int total=0;
	    for(int i=0;i < _playercopies.length;i++)
		    total += _playercopies[i];
	    
	    Class[] RET = new Class[total];
	    int curr=0;
	    for(int i=0;i < _playercopies.length;i++)
	    {
		    for(int j=0;j < _playercopies[i];j++)
		    {
			    RET[curr] = _classlist[i];
			    curr++;
		    }
	    }
	    return RET;
    }

    /*
    public Class[] playerList() throws Exception {
        int _MAX = _playerlist.length;
        Class[] RET = new Class[_MAX];
        
        System.arraycopy(_playerlist, 0, RET, 0, _MAX);
        return RET;
    }
    */

    public Class player(int __pos) throws Exception {
        return _playerlist[__pos];
    }

    public void setPlayer(int __pos, Class __class) throws Exception {
        _playerlist[__pos] = __class;
    }
    
    public String logFile() throws Exception {
        return _logfile;
    }

    public void setLogFile(String __logfile) throws Exception {
        _logfile = __logfile;
    }
}
