//***********************************************************
//*
//* File:           IFCConfiguration.java
//* Author:         Abhinav Kamra
//* Contact:        kamra@cs.columbia.edu
//* Update:         9.5.2003
//*
//* Description:    Configuration object interface.  Used to
//*                 store, specify, and retrieve
//*                 configuration parameters during
//*                 model instantiation.
//*
//***********************************************************

package ui;

import java.io.Serializable;

public interface IFCConfiguration extends Serializable {

	// Game parameters
    public void     setMaxRounds(int __maxrounds)               throws Exception;
    public int      maxRounds()                                 throws Exception;
    public void     setMaxRoundsBounds(int a, int b)		throws Exception;
    
    public int      numPlayers()                                throws Exception;
    public void     setNumPlayersBounds(int a, int b)		throws Exception;
    public int      minPlayers()                                throws Exception;
    public int      maxPlayers()                                throws Exception;

    public void     setPlayerCopies(int a, int b)		throws Exception;
    public void     setPlayerCopies(int[] c)			throws Exception;
    public int      getPlayerCopies(int a)			throws Exception;

    public void	    setGridL(int l)				throws Exception;
    public int	    GridL()					throws Exception;
    public void	    setGridW(int w)				throws Exception;
    public int	    GridW()					throws Exception;

    // Class and Players
    public void     setClassList(Class[] __list)                throws Exception;
    public Class[]  classList()                                 throws Exception;
    public Class    getClass(int __pos)                         throws Exception;
    public void     setClass(int __pos, Class __class)          throws Exception;
    public void     setPlayerList(Class[] __list)               throws Exception;
    public Class[]  playerList()                                throws Exception;
    public Class    player(int __pos)                           throws Exception;
    public void     setPlayer(int __pos, Class __class)         throws Exception;
    public String   logFile()                                   throws Exception;
    public void     setLogFile(String __str)                    throws Exception;
}
